import DS from 'ember-data';
import ENV from './../config/environment';
import DataAdapterMixin from 'ember-simple-auth/mixins/data-adapter-mixin';


var JhipsterAdapter = DS.RESTAdapter.extend(DataAdapterMixin, {
   namespace: 'api',
  authorizer: 'authorizer:token',

  handleResponse(status, headers, payload, requestData) {
     var typeKey = requestData.url.slice(this.namespace.length+2, requestData.url.length);
     var pos = typeKey.indexOf("/"); // for response on URL with an Id
     if (pos >= 1) {
         typeKey = typeKey.slice(0,pos-1);
     }
     var newPayload = {};
     newPayload[typeKey] = payload;
     // todo : how to handle embedded relationships...
     return this._super(status, headers, newPayload, requestData);
  },

});

var MirageAdapter = DS.JSONAPIAdapter.extend({
  namespace: 'api',
  shouldBackgroundReloadRecord() {
    return false;
  }
});


var FinalAdapter;
if (ENV.APP.jhipster && ENV.APP.proxy) {
   FinalAdapter = JhipsterAdapter;
} else {
   FinalAdapter = MirageAdapter;
}

export default FinalAdapter;
