import { Injectable, Component } from '@angular/core';
import { Router } from '@angular/router';
import { NgbModal, NgbModalRef } from '@ng-bootstrap/ng-bootstrap';
import { Rack } from './rack.model';
import { RackService } from './rack.service';
@Injectable()
export class RackPopupService {
    private isOpen = false;
    constructor(
        private modalService: NgbModal,
        private router: Router,
        private rackService: RackService

    ) {}

    open(component: Component, id?: number | any): NgbModalRef {
        if (this.isOpen) {
            return;
        }
        this.isOpen = true;

        if (id) {
            this.rackService.find(id).subscribe((rack) => {
                if (rack.createdAt) {
                    rack.createdAt = {
                        year: rack.createdAt.getFullYear(),
                        month: rack.createdAt.getMonth() + 1,
                        day: rack.createdAt.getDate()
                    };
                }
                this.rackModalRef(component, rack);
            });
        } else {
            return this.rackModalRef(component, new Rack());
        }
    }

    rackModalRef(component: Component, rack: Rack): NgbModalRef {
        const modalRef = this.modalService.open(component, { size: 'lg', backdrop: 'static'});
        modalRef.componentInstance.rack = rack;
        modalRef.result.then((result) => {
            this.router.navigate([{ outlets: { popup: null }}], { replaceUrl: true });
            this.isOpen = false;
        }, (reason) => {
            this.router.navigate([{ outlets: { popup: null }}], { replaceUrl: true });
            this.isOpen = false;
        });
        return modalRef;
    }
}
