import { Injectable } from '@angular/core';
import { Resolve, ActivatedRouteSnapshot, RouterStateSnapshot, Routes, CanActivate } from '@angular/router';

import { UserRouteAccessService } from '../../shared';
import { PaginationUtil } from 'ng-jhipster';

import { RackComponent } from './rack.component';
import { RackDetailComponent } from './rack-detail.component';
import { RackPopupComponent } from './rack-dialog.component';
import { RackDeletePopupComponent } from './rack-delete-dialog.component';

import { Principal } from '../../shared';

export const rackRoute: Routes = [
    {
        path: 'rack',
        component: RackComponent,
        data: {
            authorities: ['ROLE_USER'],
            pageTitle: 'Racks'
        },
        canActivate: [UserRouteAccessService]
    }, {
        path: 'rack/:id',
        component: RackDetailComponent,
        data: {
            authorities: ['ROLE_USER'],
            pageTitle: 'Racks'
        },
        canActivate: [UserRouteAccessService]
    }
];

export const rackPopupRoute: Routes = [
    {
        path: 'rack-new',
        component: RackPopupComponent,
        data: {
            authorities: ['ROLE_USER'],
            pageTitle: 'Racks'
        },
        canActivate: [UserRouteAccessService],
        outlet: 'popup'
    },
    {
        path: 'rack/:id/edit',
        component: RackPopupComponent,
        data: {
            authorities: ['ROLE_USER'],
            pageTitle: 'Racks'
        },
        canActivate: [UserRouteAccessService],
        outlet: 'popup'
    },
    {
        path: 'rack/:id/delete',
        component: RackDeletePopupComponent,
        data: {
            authorities: ['ROLE_USER'],
            pageTitle: 'Racks'
        },
        canActivate: [UserRouteAccessService],
        outlet: 'popup'
    }
];
