import { ComponentFixture, TestBed, async, inject } from '@angular/core/testing';
import { OnInit } from '@angular/core';
import { DatePipe } from '@angular/common';
import { ActivatedRoute } from '@angular/router';
import { Observable } from 'rxjs/Rx';
import { DateUtils, DataUtils, EventManager } from 'ng-jhipster';
import { JhipstercellarTestModule } from '../../../test.module';
import { MockActivatedRoute } from '../../../helpers/mock-route.service';
import { BottleDetailComponent } from '../../../../../../main/webapp/app/entities/bottle/bottle-detail.component';
import { BottleService } from '../../../../../../main/webapp/app/entities/bottle/bottle.service';
import { Bottle } from '../../../../../../main/webapp/app/entities/bottle/bottle.model';

describe('Component Tests', () => {

    describe('Bottle Management Detail Component', () => {
        let comp: BottleDetailComponent;
        let fixture: ComponentFixture<BottleDetailComponent>;
        let service: BottleService;

        beforeEach(async(() => {
            TestBed.configureTestingModule({
                imports: [JhipstercellarTestModule],
                declarations: [BottleDetailComponent],
                providers: [
                    DateUtils,
                    DataUtils,
                    DatePipe,
                    {
                        provide: ActivatedRoute,
                        useValue: new MockActivatedRoute({id: 123})
                    },
                    BottleService,
                    EventManager
                ]
            }).overrideComponent(BottleDetailComponent, {
                set: {
                    template: ''
                }
            }).compileComponents();
        }));

        beforeEach(() => {
            fixture = TestBed.createComponent(BottleDetailComponent);
            comp = fixture.componentInstance;
            service = fixture.debugElement.injector.get(BottleService);
        });


        describe('OnInit', () => {
            it('Should call load all on init', () => {
            // GIVEN

            spyOn(service, 'find').and.returnValue(Observable.of(new Bottle(10)));

            // WHEN
            comp.ngOnInit();

            // THEN
            expect(service.find).toHaveBeenCalledWith(123);
            expect(comp.bottle).toEqual(jasmine.objectContaining({id:10}));
            });
        });
    });

});
